﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using DlhSoft.Windows.Controls;

namespace LoadChartDataGridMouseEventHandlingSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            AllocationItem allocation11 = LoadChartDataGrid.Items[0].GanttChartItems[0];
            allocation11.Start = DateTime.Today.Add(TimeSpan.Parse("08:00:00"));
            allocation11.Finish = DateTime.Today.Add(TimeSpan.Parse("16:00:00"));

            AllocationItem allocation112 = LoadChartDataGrid.Items[0].GanttChartItems[1];
            allocation112.Start = DateTime.Today.AddDays(1).Add(TimeSpan.Parse("08:00:00"));
            allocation112.Finish = DateTime.Today.AddDays(1).Add(TimeSpan.Parse("12:00:00"));
            allocation112.Units = 1.5;

            AllocationItem allocation12 = LoadChartDataGrid.Items[0].GanttChartItems[2];
            allocation12.Start = DateTime.Today.AddDays(1).Add(TimeSpan.Parse("12:00:00"));
            allocation12.Finish = DateTime.Today.AddDays(2).Add(TimeSpan.Parse("16:00:00"));
            allocation12.Units = 0.5;

            AllocationItem allocation13 = LoadChartDataGrid.Items[0].GanttChartItems[3];
            allocation13.Start = DateTime.Today.AddDays(4).Add(TimeSpan.Parse("08:00:00"));
            allocation13.Finish = DateTime.Today.AddDays(4).Add(TimeSpan.Parse("16:00:00"));

            AllocationItem allocation22 = LoadChartDataGrid.Items[1].GanttChartItems[0];
            allocation22.Start = DateTime.Today.AddDays(1).Add(TimeSpan.Parse("08:00:00"));
            allocation22.Finish = DateTime.Today.AddDays(2).Add(TimeSpan.Parse("16:00:00"));
        }

        private void LoadChartDataGrid_PreviewMouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            Point controlPosition = e.GetPosition(LoadChartDataGrid);
            Point contentPosition = e.GetPosition(LoadChartDataGrid.ChartContentElement);

            DateTime dateTime = LoadChartDataGrid.GetDateTime(contentPosition.X);
            LoadChartItem itemRow = LoadChartDataGrid.GetItemAt(contentPosition.Y) as LoadChartItem;

            AllocationItem item = null;
            FrameworkElement frameworkElement = e.OriginalSource as FrameworkElement;
            if (frameworkElement != null)
                item = frameworkElement.DataContext as AllocationItem;

            if (controlPosition.X < LoadChartDataGrid.ActualWidth - LoadChartDataGrid.GanttChartView.ActualWidth)
                return;
            if (controlPosition.Y < LoadChartDataGrid.HeaderHeight)
                MessageBox.Show(string.Format("You have clicked the chart scale header at date and time {0:g}.", dateTime), "Mouse Click Details", MessageBoxButton.OK);
            else if (item != null)
                MessageBox.Show(string.Format("You have clicked the allocation item '{0}' of resource item '{1}' at date and time {2:g}.", item, itemRow, dateTime > item.Finish ? item.Finish : dateTime), "Mouse Click Details", MessageBoxButton.OK);
            else if (itemRow != null)
                MessageBox.Show(string.Format("You have clicked at date and time {0:g} within the row of item '{1}'.", dateTime, itemRow), "Mouse Click Details", MessageBoxButton.OK);
            else
                MessageBox.Show(string.Format("You have clicked at date and time {0:g} within an empty area of the chart.", dateTime), "Mouse Click Details", MessageBoxButton.OK);
        }
    }
}
